//dreiecke.cc

/***** dieser Teil von grafikstart.cc (Stammprogramm) uebernommen: *****/
//grafikstart.cc
#define VERSION "Version 0.0"
#include <stdio.h>
#include <stdlib.h>
#ifndef GCC_VERSION
#define GCC_VERSION (__GNUC__ * 1000 + __GNUC_MINOR__)
#endif
#if GCC_VERSION>=3000
#include <iostream>
using namespace std;
#else
#include <stream.h>
#endif
#ifdef AMIGA
#include <amitekplot1.h>
#else
#include <xtekplot1.h>
#endif

const int XMAX=640,YMAX=512,TIEFE=4;
static int breite,hoehe,tiefe,visklasse; //Globale Variablen
static double xmin= -0.1, ymin=0.0, xmax=1.1, ymax=1.0;
static int exitflag=0;
void menu_exit() {exitflag=1;}
/***** bis hier unveraendert von grafikstart.cc uebernommen *****/

/** einfacher 2-dimensionaler Vektor **/
class Vector
{
 double ko[2]; //ko[0]=x-Koordinate  ko[1]=y-Koordinate
public:
 Vector() {}
 Vector(double x,double y) {ko[0]=x; ko[1]=y;}
 double x() {return ko[0];}
 double y() {return ko[1];}
 double& operator[](int i) {return ko[i];}
 double operator=(Vector v) {ko[0]=v.ko[0]; ko[1]=v.ko[1];}
 double operator+=(Vector v) {ko[0] += v.ko[0];  v.ko[1] += v.ko[1];}
 friend Vector operator+(Vector,Vector);
};

Vector operator+(Vector v1,Vector v2)
{
 Vector v;
 v.ko[0]=v1.ko[0]+v2.ko[0];
 v.ko[1]=v1.ko[1]+v2.ko[1];
 return v;
}

/** Variante fuer groessere Vektoren **
class Vector
{
 double *ko; //ko[0]=x-Koordinate  ko[1]=y-Koordinate
 int max;
public:
 Vector() {ko=new double[max=2];}
 ~Vector() {delete[] ko;}
 Vector(int n) {ko=new double[max=n];}
 Vector(double x,double y) {ko=new double[max=2]; ko[0]=x; ko[1]=y;}
};
**/

class Kante
{
 int k[2];//Indexe auf die Ecken
public:
 void set(int a,int b) {k[0]=a; k[1]=b;}
 int a() {return k[0];}
 int b() {return k[1];}
};
class Figur
{
 int maxn,neck,nkant;
 Vector *eck;
 Kante *kant;
public:
 Figur(int n);
 int getn() {return neck;}
 int ecke(double x,double y) {eck[neck]=Vector(x,y); return neck++;}
 int kante(int a,int b) {kant[nkant].set(a,b); return nkant++;}
 void zeichnen(int farbe=1);
 Vector& operator[](int i) {return eck[i];}
};
Figur::Figur(int n)
{
 int n2=n*n/2;
 eck=new Vector[maxn=n];
 kant=new Kante[n2];
 neck=0; nkant=0;
}

void linie(Vector a,Vector b)
{
 plot(a[0],a[1],PENUP); plot(b[0],b[1],PENDOWN);
}
void Figur::zeichnen(int farbe)
{
 for(int i=0;i<nkant;i++)
   {int a=kant[i].a(), b=kant[i].b();
    linie(eck[a],eck[b]);
   }
}
class Dreieck:public Figur
{
public:
 Dreieck(double,double,double,double,double,double);
};
Dreieck::Dreieck(double x1,double y1,
		 double x2,double y2,
		 double x3,double y3) : Figur(3)
{
 ecke(x1,y1); ecke(x2,y2); ecke(x3,y3);
 kante(0,1); kante(1,2); kante(2,0);
}
static Dreieck dreieck(0.05, 0.07,   0.9, 0.0,   0.12, 1.0);

const int SCHWARZ=0,WEISS=1,ROT=2,GRUEN=3,BLAU=4;//defaults von xtekplot
void grafik_zeichnen()
{
 dreieck.zeichnen(GRUEN);
}

/***** dieser Teil von grafikstart.cc (Stammprogramm) uebernommen: *****/
main(int argc,char *argv[])
{
 //tek_setdebug(1);//test
 if(argc>1 && *argv[1]=='?')
    {printf("programmname  %s\n",VERSION); exit(0);}
 getmaxsize(&breite,&hoehe,&tiefe,&visklasse);
 if(breite>XMAX) breite=XMAX;  if(hoehe>YMAX) hoehe=YMAX;
 if(tiefe>TIEFE) tiefe=TIEFE;
 setsize(breite,hoehe,tiefe);
 setmenu(1,"File");
 setmenu(1,"Exit",&menu_exit);
 inital(xmin,ymin,xmax,ymax); /* Grafikfenster oeffnen */
 grafik_zeichnen();
 term_refresh();
 while(exitflag==0 && waitmenu(1)==0)
        ;// auf Benutzereingaben warten
 inital_new();
 term_exit();
 return 0;
}// ende von main
